function varargout = bspgui(varargin)
% BSPGUI M-file for bspgui.fig
%      BSPGUI, by itself, creates a new BSPGUI or raises the existing
%      singleton*.
%
%      H = BSPGUI returns the handle to a new BSPGUI or the handle to
%      the existing singleton*.
%
%      BSPGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BSPGUI.M with the given input arguments.
%
%      BSPGUI('Property','Value',...) creates a new BSPGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before bspgui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to bspgui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help bspgui

% Last Modified by GUIDE v2.5 09-Sep-2003 13:38:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @bspgui_OpeningFcn, ...
                   'gui_OutputFcn',  @bspgui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
return

% --- Executes just before bspgui is made visible.
function bspgui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to bspgui (see VARARGIN)

% Choose default command line output for bspgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using bspgui.
if strcmp(get(hObject,'Visible'),'off')
    
    % Handles for each of the axes
    handles.hAxes = [handles.axes1 handles.axes2 handles.axes3];
      
    % data axes limits.  There are some interactions with the camera
    % and the sizing and location of the plot box.  Symmetric limits
    % for each axis often seem to work best.
    
    handles.scene_limits = cell(3);
    handles.scene_limits{1} = [-4 4 -4 4 -4 4];       % un-processed scene
    handles.scene_limits{2} = [-4 4 -4 4 -4 4];       % processed scene
    handles.scene_limits{3} = [-20 20 -10 10 -1 1];   % the tree
    
    % The tick arrays may be different sizes.
    % One cell column per scene, one cell row each for x, y, and z
    
    handles.ticks = cell(3,3);
    for k = 1:2
        handles.ticks{1,k} = [handles.scene_limits{k}(1) : 4 : handles.scene_limits{k}(2)];
        handles.ticks{2,k} = [handles.scene_limits{k}(3) : 4 : handles.scene_limits{k}(4)];
        handles.ticks{3,k} = [handles.scene_limits{k}(5) : 4 : handles.scene_limits{k}(6)];
    end
    
    % Only true before the user has seen (and possibly reoriented) the 
    % display.  Controls whether or not we initialize the viewing parameters.
    
    handles.first_look = 1;
    
    % We add a little function hook later on so that when the user adjusts the
    % view in axes 1, we get a chance to do the same with axes 2.
    
    handles.WindowButtonUpFcn = [];
    
    % The xyz coordinate frame end points
    % Defines the origin and the end point of each line
    % Each column is [x y z]'
    
    handles.gFrame = [ ...
        0 1 0 0; ...
        0 0 1 0; ...
        0 0 0 1];

    % Define several sets of initial faces.  One cell per set. If you add
    % more sets,  remember to update the possible selections in the gui
    % control. Each cell contains an array of one or more polygon structs.
    
    handles.faces = cell(1,3);
        
    handles.faces{1} = [];
    f1 = [[-2.1 -2.2 0]' [-1.2 -1.8 0]' [-1.2 -1.8 1]' [-2.1 -2.2 1]'];
    f2 = [[-1.2 1.2 0]' [-2.1 2 0]' [-2.1 2 1]' [-1.2 1.2 1]'];
    f3 = [[.8 1 0]' [.2 -.2 0]' [.2 -.2 1]' [.8 1 1]'];
    f4 = [[1 -2.2 0]' [2 -1.5 0]' [2 -1.5 1]' [1 -2.2 1]'];
    f5 = [[2 2.2 0]' [.2 3 0]' [.2 3 1]' [2 2.2 1]'];
    handles.faces{1} = [newPolygon(f1,'1') newPolygon(f2,'2') newPolygon(f3,'3') newPolygon(f4,'4') newPolygon(f5,'5')];

    handles.faces{2} = [];
    for k = 1:3
        x = (2*k)-4;
        p0 = [x -2 -2]';
        p1 = [x 0 4]';
        p2 = [x 4 0]';
        handles.faces{2} = [handles.faces{2} newPolygon([p0 p1 p2],num2str(k))];
    end
    
    handles.faces{3} = [];
    f1 = [[-1.5 -1 0]' [1.5 -1 0]' [1.5 -1 1]' [-1.5 -1 1]'];
    f2 = [[-2 1.5 0]' [-2 1.5 1]' [-1 0 1]' [-1 0 0]'];
    f3 = [[2 1.5 0]' [1 0 0]' [1 0 1]' [2 1.5 1]'];
    handles.faces{3} = [newPolygon(f1,'1') newPolygon(f2,'2') newPolygon(f3,'3')];

    % The root of the bsp tree.
    % The initial tree has only one node, which has no assigned polygon.
    % The associated front list has all the polygons in the scene and the
    % back list is empty.
    
    frontList = [handles.faces{get(handles.select_poly,'Value')}];
    backList = [];
    element = bspElement([],frontList,backList);
    handles.root = bspNode(element,[],[]);
    
    handles.scanner = [0 4 0]';

    guidata(hObject, handles);
end
drawFigure(hObject)
return

% UIWAIT makes bspgui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --------------------------------------------------------------------
% --- Outputs from this function are returned to the command line.
function varargout = bspgui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
return

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
return

% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end
return

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)
return

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)
return

% --------------------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function select_poly_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_poly (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------
% --- Executes on button press in any of the general checkbox options.
function show_option_Callback(hObject, eventdata, handles)
drawFigure(hObject)
return

% --------------------------------------------------------------------
% --- Executes on button press in the select_poly drop down control
% Clear the tree that has been built for the previous set of faces
% then recalculate and redraw
function select_poly_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
frontList = [handles.faces{get(handles.select_poly,'Value')}];
backList = [];
element = bspElement([],frontList,backList);
handles.root = bspNode(element,[],[]);
guidata(hObject, handles);
drawFigure(hObject)
return

% --------------------------------------------------------------------
% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
frontList = [handles.faces{get(handles.select_poly,'Value')}];
backList = [];
element = bspElement([],frontList,backList);
handles.root = bspNode(element,[],[]);
guidata(hObject, handles);
drawFigure(hObject)
return

% --------------------------------------------------------------------
% --- Executes on mouse press over axes2 background.
function axes2_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to axes2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject);
cp = get(hObject,'CurrentPoint');
handles.scanner = cp(2,:)';
guidata(hObject, handles);
drawFigure(hObject)
return

% --------------------------------------------------------------------
% --- Executes on mouse press over a node list item.
% This function implements the split list around polygon portion of the
% make BSP tree algorithm.  When the user clicks on a particular polygon
% in a list, this function splits the list around that polygon and builds
% a new node for the BSP tree with the result.
% This function assumes that the UserData of the associated text object is
% a cell array.  The first cell is the integer index of the associated
% polygon in the list of polygons found in the second cell.  This user data
% structure is created when the text item is drawn on screen.
function NodeListItem_ButtonDownFcn(hObject, eventdata)
handles = guidata(hObject);

udata = get(hObject,'UserData');
index = udata{1};
polyList = udata{2};

front = [];
back = [];

% split the list depending on where the polys are located

for k = 1:length(polyList)
    if k == index
        continue
    end
    c = inFront(polyList(k).points,polyList(index));
    if c == -1                          % in front of splitting poly
        front = [front polyList(k)];
    elseif c == +1                      % in back of splitting poly
        back = [back polyList(k)];
    else                                % needs to be split.
        [fPoly bPoly] = splitPoly(polyList(k),polyList(index));
        front = [front fPoly];
        back = [back bPoly];
    end
end

element = bspElement(polyList(index),front,back);
node = bspNode(element,[],[]);

if size(front,2) == 1       % only one poly left in front list, make it a node
    node.element.front = [];
    element = bspElement(front,[],[]);
    node.left = bspNode(element,[],[]);
end

if size(back,2) == 1       % only one poly left in back list, make it a node
    node.element.back = [];
    element = bspElement(back,[],[]);
    node.right = bspNode(element,[],[]);
end

handles.root = bspInsertNode(handles.root,node);
guidata(hObject, handles);
drawFigure(hObject)
return

% --------------------------------------------------------------------
function [frontPoly, backPoly] = splitPoly(polyA,polyB)
% Split polygon A in two using the plane defined by polygon B as the 
% cutter.
% polyA and polyB are the input polygon structs
% frontPoly and backPoly are the output polygons, the front and back
% sections of polyA

ptsF = [];
ptsB = [];

% points that define the plane Ax+By+Cz+D = 0.

% A = polyB.normal(1);
% B = polyB.normal(2);
% C = polyB.normal(3);
D = -dot(polyB.points(:,1),polyB.normal);

% initialize so that first point is never a crossing point

lastSide = inFront(polyA.points(:,1),polyB);

% put each point on the correct side or split if a line segment crosses the
% plane

for k = 1:size(polyA.points,2)
    side = inFront(polyA.points(:,k),polyB);
    if side == lastSide
        if side == -1 || side == 0      % front or coplanar
            ptsF = [ptsF polyA.points(:,k)];
        else                            % back
            ptsB = [ptsB polyA.points(:,k)];
        end
    else                                % crossed the plane
        lastSide = side;
        p1 = polyA.points(:,k-1);
        p2 = polyA.points(:,k);
        dir = p2-p1;
        t = -(dot(polyB.normal,p1)+D)/dot(polyB.normal,dir);
        if side == +1                   % going from front to back
            ptsF = [ptsF p1+t*dir];
            ptsB = [ptsB p1+t*dir p2];
        else                            % going from back to front
            ptsF = [ptsF p1+t*dir p2];
            ptsB = [ptsB p1+t*dir];
        end
        
    end
end

% bug
% the problem I'm trying to check for is a backside polygon with one
% point or edge that is on the plane.  This doesn't work ...

if size(ptsF,2) <= 2
    frontPoly = [];
else
    frontPoly = newPolygon(ptsF,[polyA.label 'a']);
end
    
if size(ptsB,2) <= 2
    backPoly = [];
else
    backPoly = newPolygon(ptsB,[polyA.label 'b']);
end
return

% --------------------------------------------------------------------
function drawFigure(hObject)
% drawFigure Draw all the GUI images.
% hObject a figure or figure child object with which we can obtain access
% to the handles struct.

handles = guidata(hObject);

% set up the common aspects of the scenes

axes(handles.hAxes(1))
cv = view;      % save the current viewpoint

for idx = 1:3
    axes(handles.hAxes(idx))
    cla
    set(gca,'CameraViewAngleMode','auto')
    set(gca,'DataAspectRatioMode','auto')
    set(gca,'PlotBoxAspectRatioMode','auto')
    
    set(gca,'XLim',handles.scene_limits{idx}(1:2))
    set(gca,'YLim',handles.scene_limits{idx}(3:4))
    set(gca,'ZLim',handles.scene_limits{idx}(5:6))
    
    set(gca,'XTick',handles.ticks{1,idx})
    set(gca,'XTickLabel',handles.ticks{1,idx})
    set(gca,'YTick',handles.ticks{2,idx})
    set(gca,'YTickLabel',handles.ticks{2,idx})
    set(gca,'ZTick',handles.ticks{3,idx})
    set(gca,'ZTickLabel',handles.ticks{3,idx})
    grid on
end

for idx = 1:2
    axes(handles.hAxes(idx))
    
    light('Position',[-4 -4 10])
    
    % draw the global coordinate frame 
    
    if get(handles.show_coordinate_frame,'Value')
        line(handles.gFrame(1,1:2)',handles.gFrame(2,1:2)',handles.gFrame(3,1:2)',...
            'LineWidth',.5,'Color','r');
        line([handles.gFrame(1,1);handles.gFrame(1,3)],...
            [handles.gFrame(2,1);handles.gFrame(2,3)],...
            [handles.gFrame(3,1);handles.gFrame(3,3)],...
            'LineWidth',.5,'Color','g');
        line([handles.gFrame(1,1);handles.gFrame(1,4)],...
            [handles.gFrame(2,1);handles.gFrame(2,4)],...
            [handles.gFrame(3,1);handles.gFrame(3,4)],...
            'LineWidth',.5,'Color','b');
    end

    % set the viewpoint
    
    if handles.first_look
        view(3)
    else
        view(cv)
    end
end

% draw the original polygons in axes 1

objects = handles.faces{get(handles.select_poly,'Value')};
axes(handles.hAxes(1))
for k=1:length(objects)
    plotPolygon(objects(k))
end

% draw the BSP tree polygons in axes 2

axes(handles.hAxes(2))
btInOrder(handles.root,@bspPlot3Element)
    
% draw the scanner marker and fill in the scan display text

if get(handles.show_scanner,'Value')
    h = line(handles.scanner(1),handles.scanner(2),handles.scanner(3),'Marker','*');
    set(h,'HitTest','off','MarkerEdgeColor','r','MarkerFaceColor','r');
    
    set(handles.scanX,'String',sprintf('%3.1f',handles.scanner(1)))
    set(handles.scanY,'String',sprintf('%3.1f',handles.scanner(2)))
    set(handles.scanZ,'String',sprintf('%3.1f',handles.scanner(3)))
    
    set(handles.scan_list,'String','')
    bspFarToNear(handles.scanner,handles.root,@updateScanList)

else
    set(handles.scanX,'String',' ')
    set(handles.scanY,'String',' ')
    set(handles.scanZ,'String',' ')
    
    set(handles.scan_list,'String','')
end

% draw the BSP tree in axes 3

axes(handles.hAxes(3))
cla
view(2)
grid off
btPlotTree(handles.root,@bspPlotElement)

% Unfortunately keeping the button properties set appears to be
% somewhat difficult.  rotate3D resets everybody else's bdf.
% I imagine that I'm overlooking something, but this save/restore
% works okay for now.

h = findobj(handles.hAxes(3));
bdf = get(h,'ButtonDownFcn');

handles.first_look = 0;                              % remember the view from now on
rotate3d(handles.hAxes(1))                           % let the user change view 1
handles.WindowButtonUpFcn = get(gcf,'WindowButtonUpFcn');
set(gcf,'WindowButtonUpFcn',@wrapWindowButtonUpFcn)  % and copy it in view 2
guidata(gca, handles);

set(h,{'ButtonDownFcn'},bdf)            % restore the active text objects in the tree
set(handles.axes2,'ButtonDownFcn',@axes2_ButtonDownFcn)
return

% --------------------------------------------------------------------
function updateScanList(element)
% Add the node label to the scan list display
handles = guidata(gca);
current = get(handles.scan_list,'String');
if isempty(current)
    set(handles.scan_list,'String',element.poly.label);
else
    if ~iscellstr(current)
        current = cellstr(current);
    end
    m = size(current,1);
    current(m+1) = cellstr(element.poly.label);
    set(handles.scan_list,'String',current)
end
return

% --------------------------------------------------------------------
function plotPolygon(polygon)
% Draw the given polygon
% polygon is a struct defined by newPolygon

if isempty(polygon)
    return
end

handles = guidata(gca);

p = polygon.points;
h = patch([p(1,:) p(1,1)]',[p(2,:) p(2,1)]',[p(3,:) p(3,1)]','b');
set(h,'HitTest','off','FaceColor',[.5 .5 .9],'FaceLighting','gouraud')

center = mean(polygon.points,2);

if get(handles.show_normals,'Value')
	h = line([center(1) center(1)+polygon.normal(1)]',...
        [center(2) center(2)+polygon.normal(2)]',...
        [center(3) center(3)+polygon.normal(3)]');
	set(h,'HitTest','off','Color','b')
end

if get(handles.show_labels,'Value')
    if get(handles.show_normals,'Value')
        loc = center + polygon.normal;
    else
        loc = center + .5 * polygon.normal;
    end
	h = text(loc(1),loc(2),loc(3),polygon.label);
	set(h,'HitTest','off','VerticalAlignment','bottom','HorizontalAlignment','center')
end
    
return

% --------------------------------------------------------------------
function wrapWindowButtonUpFcn(hObject, eventdata)
% This function executes whenever the user lets up on the mouse button. The
% idea is that the user may have been adjusting the view in axes 1, so we
% should reset the view in axes 2 to match.
handles = guidata(hObject);
eval(handles.WindowButtonUpFcn);
axes(handles.hAxes(1))
cv = view;
axes(handles.hAxes(2))
view(cv)
return

% --------------------------------------------------------------------
function e = newPolygon(p,label)
% Create a new struct describing a polygon face.
% Each vertex pn of the polygon is represented as a vector 
% pn = [x y z]' by a column of matrix p.  There must be at least three points.
% label is optional and is a text string label for this polygon.
% The points are assumed to be specified in counterclockwise order
% (winding) and the polygon normal is defined to be cross(p2-p1,p3-p1).
% The positive normal direction is "in front" of the face.
% Fields in a polygon struct:
%   points      3xN array of points
%   normal      3x1 positive normal direction
%   label       string label for this polygon

n = cross(p(:,2)-p(:,1),p(:,3)-p(:,1));
n = n ./ norm(n);

e = struct('label','','points',p,'normal',n);

if nargin > 1
    e.label = label;
end
return

% --------------------------------------------------------------------
function t = inFront(pts,polygon)
% inFront Return -1, 0, or +1 as all, some, or none of the given points are
% in front of the plane defined by the given polygon.
% pts       The columns [x y z]' of pts are the points to check.
% polygon   The polygon struct that defines the reference plane.
% Note that there is a little fudge factor.  Points that are very close to
% the plane are considered to be on the plane.

% get vectors from one corner of the polygon to all the points to be
% checked

d = pts-repmat(polygon.points(:,1),1,size(pts,2));

% take the dot product of those vectors with the polygon normal

p = d'*polygon.normal;

epsilon = 1e-10;        % dot product of perpendiculars is not exactly zero

f = (p >= -epsilon);    % all pts in front of (or on) the plane?
if all(f)
    t = -1;             % in front
else
    f = (p <= epsilon); % all pts in back of (or on) the plane?
    if all(f)
        t = +1;         % in back
    else
        t = 0;          % intersects
    end
end

return

% --------------------------------------------------------------------
function displayPolygon(polygon)
% Display information about the given polygon.
% polygon is a struct defined by newPolygon
if isempty(polygon)
    disp('null polygon')
    return
end

disp(['polygon: ' polygon.label ' has ' num2str(size(polygon.points,2)) ' points.'])
return

% --------------------------------------------------------------------
function e = bspElement(p,f,b)
% Create a new struct holding information about a BSP tree node
% Fields in a bspElement struct:
%   poly    a polygon struct
%   front   vector of handles.polys subscripts for front list
%   back    vector of handles.polys subscripts for back list

e = struct('poly',p,'front',f,'back',b);
return

% --------------------------------------------------------------------
function n = bspNode(e,left,right)
% Create a new node for a BSP tree.
% Fields in a node:
%   element     the bspElement that contains the node's data
%   left        empty array or another node
%   right       empty array or another node

n = struct('element',e,'left',left,'right',right);
return

% --------------------------------------------------------------------
function t = bspInsertNode(tree,node)
% Insert a node in a BSP tree.  This function performs two tasks that 
% involve knowledge of the structure of a bspElement.
% 1. We need to throw away a pseudo-root that has a bspElement 
% but no associated polygon.
% 2. We need to delete the front or back list of any parent node
% that actually has front or back child nodes.
% tree      the root of the existing tree
% node      the node to insert

makeRoot = false;
if isempty(tree)
    makeRoot = true;
elseif ~isempty(tree.element) && isempty(tree.element.poly)
    makeRoot = true;
end

if makeRoot
    t = node;
    return
end

if bspInFront(node,tree)
    tree.element.front = [];
    t = bspNode(tree.element,bspInsertNode(tree.left,node),tree.right);
else
    tree.element.back = [];
    t = bspNode(tree.element,tree.left,bspInsertNode(tree.right,node));
end

return

% --------------------------------------------------------------------
function bspPlot3Element(element)
% plot the polygon described by the given bspElement
plotPolygon(element.poly)
return

% --------------------------------------------------------------------
function bspPlotElement(pos,element)
% plot the given bspElement
% pos is a vector of [x dx y dy] in data units

x = pos(1);
dx = pos(2);
y = pos(3);
dy = pos(4);

if ~isempty(element.front)
    cx = x-(dx/2);
    cy = y-dy;
    line([x cx]',[y cy]','Color',[.9 .7 .7],'HitTest','off');
    bspPlotList([cx dx cy dy],element.front)
end

if ~isempty(element.back)
    cx = x+(dx/2);
    cy = y-dy;
    line([x cx]',[y cy]','Color',[.9 .7 .7],'HitTest','off');
    bspPlotList([cx dx cy dy],element.back)
end

if isempty(element.poly)
    h = line(x,y,'Marker','o','MarkerFaceColor','w');
    set(h,'HitTest','off')
else
    if isempty(element.poly.label)
        h = text(x,y,'no label');
    else
        h = text(x,y,element.poly.label);
    end
	set(h,'HitTest','off')
	set(h,'BackgroundColor','w','EdgeColor','b','HorizontalAlignment','center')
end

return

% --------------------------------------------------------------------
function bspPlotList(pos,polyList)
% plot the given bsp poly list at the given position.
% pos is a vector of [x dx y dy] in data units
% polyList is a vector of polygon structs

x = pos(1);
dx = pos(2);
y = pos(3);
dy = pos(4);

if isempty(polyList)
    return
end

for k = 1:length(polyList)
    h = text(x,y,polyList(k).label,'BackgroundColor','w');
    udata = cell(1,2);
    udata{1} = k;
    udata{2} = polyList;
    set(h,'UserData',udata)
    set(h,'ButtonDownFcn',@NodeListItem_ButtonDownFcn)
    set(h,'HitTest','on')
    pt = get(h,'Extent');
    y = y-pt(4);
end

return

% --------------------------------------------------------------------
function bspFarToNear(viewer,tree,f)
% Traverse a BSP tree in far to near order, depending on viewer position.
% viewer is [x y z]' position as a column vector.
% tree is a bsp tree.  In this usage, left is in front, right is behind.
% f is a function handle.  f(tree.element) is evaluated at each node.

if isempty(tree) || isempty(tree.element) || isempty(tree.element.poly)
    return
end

t = inFront(viewer,tree.element.poly);
if  t == -1 || t == 0
    bspFarToNear(viewer,tree.right,f)
    feval(f,tree.element)
    bspFarToNear(viewer,tree.left,f)
else
    bspFarToNear(viewer,tree.left,f)
    feval(f,tree.element)
    bspFarToNear(viewer,tree.right,f)
end
return

% --------------------------------------------------------------------
function t = bspInFront(nodeA,nodeB)
% Compare two BSP tree nodes.  Return true if nodeA is completely or
% partially in front of nodeB, false otherwise.  Points in the polygon
% described by nodeA that are coplanar with the polygon in nodeB are 
% considered to be in front of it.
% It is assumed that the polygons actually added to the tree will have been
% split so that they never overlap.

if isempty(nodeA)           % null node precedes all others
    t = true;
    return
end
if isempty(nodeB)
    t = false;
    return
end

if isempty(nodeA.element)   % node with null element precedes all others
    t = true;
    return
end
if isempty(nodeB.element)
    t = false;
    return
end

if isempty(nodeA.element.poly)   % node with null poly precedes all others
    t = true;
    return
end
if isempty(nodeB.element.poly)
    t = false;
    return
end

c = inFront(nodeA.element.poly.points,nodeB.element.poly);
if c == -1 || c ==0
    t = true;
else
    t = false;
end
return
