function h = btHeight(tree)
% Discover the height of a given binary tree.
% The height of a tree is same as the depth of
% the deepest node.  The minimum height is zero.

if isempty(tree)                                    % empty tree
    h = 0;
elseif isempty(tree.left) && isempty(tree.right)    % leaf node
    h = 0;
else
    h = 1+max(btHeight(tree.left),btHeight(tree.right));
end
return
