function btInOrder(tree,f)
% Traverse a binary tree, calling function f for each element.
% tree is the root node of the tree to be plotted.
% f is a function f(node.element) that performs a useful function
% with the data in the element field of a node.

if isempty(tree)
    return
end

if ~isempty(tree.left)
    btInOrder(tree.left,f)
end

feval(f,tree.element)

if ~isempty(tree.right)
    btInOrder(tree.right,f)
end

return
