function t = btInsertNode(tree,node,compare)
% insert a node in a binary tree
% tree      the root of the existing tree
% node      the node to insert
% compare   comparator function handle.  compare(nodeA,nodeB) returns
%           true if nodeA is less than nodeB, false otherwise.

if isempty(tree)
    t = node;
    return
end

if feval(compare,node,tree)
    t = btNode(tree.element,btInsertNode(tree.left,node,compare),tree.right);
else
    t = btNode(tree.element,tree.left,btInsertNode(tree.right,node,compare));
end
return
